/*
	La version toujours plus dveloppe de l'applet "maison"
	Possibilit de slectionner des figures et surtout de modifier
	leur taille avec la souris.

	(C) J. Ferber - Octobre 2000
*/

package maison;

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.util.Vector;

/** Racine des figures qui sont dessines dans un rectangle.
	En fait la plupart des figures a part les lignes...
*/

abstract class RectangularFigure extends MovingFigure {

	int selectedHandle=0;
	final int NO_HANDLE=0;
	final int LEFT_TOP_HANDLE=1;
	final int RIGHT_TOP_HANDLE=2;
	final int LEFT_BOTTOM_HANDLE=3;
	final int RIGHT_BOTTOM_HANDLE=4;
	final int LEFT_HANDLE=5;
	final int TOP_HANDLE=6;
	final int RIGHT_HANDLE=7;
	final int BOTTOM_HANDLE=8;


	Figure cloneFig(int x0, int y0, int x1, int y1, int coul){
          try{
            RectangularFigure f = (RectangularFigure) clone();
            if (x1 < x0){
                     int x = x1;
                     x1 = x0;
                     x0 = x;
             }
             if (y1 < y0){
                      int y = y1;
                      y1 = y0;
                      y0 = y;
              }

	      f.setPos(x0,y0);
	      f.setColor(coul);
              f.setSize(x1 - x0,y1 - y0);
            return f;
          } catch(CloneNotSupportedException e){
              System.out.println("Clone impossible : "+ e.getMessage());
          }
          return(null);
        }
       void setSize(int l1, int h1){
		l = l1;
		h = h1;
	}


    boolean contains(Point p){
        return((x <= p.x) && (y <= p.y) && (p.x <= x+l) && (p.y <= y+h));
    }


	public void doReSelect(int _x, int _y){
		selectedHandle = getHandleNum(_x,_y); 
	}

	public void doDrag(Graphics g, int dx, int dy){
			// System.out.println(":: drag, handle: " + selectedHandle);
        	display(g,x,y,l,h);
			switch (selectedHandle){
				case NO_HANDLE : x+=dx; y+=dy; break;
				case LEFT_TOP_HANDLE : x = x+dx; y = y+dy; h = h-dy; l = l-dx; break;
				case RIGHT_TOP_HANDLE : y = y+dy; h = h-dy; l = l+dx; break;
				case LEFT_BOTTOM_HANDLE : x = x+dx; h = h+dy; l = l-dx;break;
				case RIGHT_BOTTOM_HANDLE : h = h+dy; l = l+ dx; break;
				case LEFT_HANDLE : x = x+dx; l = l-dx; break;
				case RIGHT_HANDLE : l = l+dx; break;
				case TOP_HANDLE : y = y+dy; h = h-dy; break;
				case BOTTOM_HANDLE : h = h+dy; break;
				default : break;
			}
        	display(g,x,y,l,h);
	}

	public void setSelected(boolean b){
		super.setSelected(b);
		selectedHandle = NO_HANDLE;
	}

 	abstract void display(Graphics g, int x, int y, int l, int h);

	void displayHandles(Graphics g){
		int s = HANDLE_SIZE;
		g.setColor(Color.blue);
		g.fillRect(x,y,s,s);		// left top
		g.fillRect(x+l-s,y,s,s);	// right top
		g.fillRect(x,y+h-s,s,s);	// left bottom
		g.fillRect(x+l-s,y+h-s,s,s);// right bottom

		g.fillRect(x,y+(h-s)/2,s,s); // gauche
		g.fillRect(x+(l-s)/2,y,s,s); // haut
		g.fillRect(x+l-s,y+(h-s)/2,s,s); // droite
		g.fillRect(x+(l-s)/2,y+h-s,s,s); // bas
	}

	int getHandleNum(int _x, int _y){
		int s = HANDLE_SIZE;
		   if ((_x >= x) && (_y >= y) && (_x <= x+s) && (_y <= y+s)) return LEFT_TOP_HANDLE;
		else if ((_x >= x+l-s) && (_y >= y) && (_x <= x+l) && (_y <= y+s)) return RIGHT_TOP_HANDLE;
		else if ((_x >= x) && (_y >= y+h-s) && (_x <= x+s) && (_y <= y+h)) return LEFT_BOTTOM_HANDLE;
		else if ((_x >= x+l-s) && (_y >= y+h-s) && (_x <= x+l) && (_y <= y+h)) return RIGHT_BOTTOM_HANDLE;

		else if ((_x >= x) && (_y >= y+(h-s)/2) && (_x <= x+s) && (_y <= y+s+(h-s)/2)) return LEFT_HANDLE;
		else if ((_x >= x+(l-s)/2) && (_y >= y) && (_x <= x+s+(l-s)/2) && (_y <= y+s)) return TOP_HANDLE;
		else if ((_x >= x+l-s) && (_y >= y+(h-s)/2) && (_x <= x+l) && (_y <= y+s+(h-s)/2)) return RIGHT_HANDLE;
		else if ((_x >= x+(l-s)/2) && (_y >= y+h-s) && (_x <= x+s+(l-s)/2) && (_y <= y+h)) return BOTTOM_HANDLE;
		else return NO_HANDLE;
	}


	void dessiner(Graphics g){
		g.setColor(getColor(couleur));
		display(g,x,y,l,h);
		if (selected)
			displayHandles(g);
	}

 	void drawBuild(Graphics g, int ox, int oy, int nx, int ny){
  		display(g,ox,oy,nx-ox,ny-oy);
  	}


    void translate(Graphics g, int dx, int dy){
        	display(g,x,y,l,h);
        	x+=dx;
         	y+=dy;
            display(g,x,y,l,h);
    }
}